<template>
	<div class="q-py-xl">
		<div class="row q-gutter-y-md" v-if="!notFound && !loading">
			<breadcrumbs :name="details.name" class="q-ml-md q-mb-lg col-11" />
			<div class="col-12 col-md-5">
				<div class="q-mx-md q-gutter-y-md">
					<header-title
						className="justify-center"
						:title="details.name"
						class="lt-md"
					/>

					<div
						class="row items-center justify-center bordered-radius shadow-10"
						:class="`bg-${getTypeColor(details.types[0].type.name)}`"
					>
						<img
							width="300px"
							height="400px"
							class="q-ma-lg avatar"
							:src="profileImage"
						/>
					</div>

					<div class="text-subtitle1 lt-md q-mt-md">
						{{ getDescription }}
					</div>

					<div class="type-match row q-py-md">
						<div class="col-12">
							<primary-title title="Type" />
						</div>
						<q-chip
							:color="getTypeColor(type.type.name)"
							class="text-thin text-white shadow-6 text-subtitle1"
							v-for="(type, typeIndex) in details.types"
							:key="`${typeIndex}A`"
							>{{ type.type.name }}</q-chip
						>
					</div>

					<div class="type-match row">
						<div class="col-12">
							<primary-title title="Strengths" className="text-green-8" />
						</div>
						<span v-if="!strengths.length" class="text-bold">
							{{ details.name | capitalize }} has no available strenght/s
						</span>
						<q-chip
							v-else
							:color="getTypeColor(strength)"
							class="text-thin text-white text-subtitle1 shadow-6"
							v-for="(strength, typeIndex) in strengths"
							:key="`${typeIndex}A`"
							>{{ strength }}</q-chip
						>
					</div>

					<div class="type-match row q-mt-lg">
						<div class="col-12">
							<primary-title title="Weakness" className="text-negative" />
						</div>
						<span v-if="!weakness.length" class="text-bold">
							{{ details.name | capitalize }} has no available weakness
						</span>
						<q-chip
							v-else
							:color="getTypeColor(weak)"
							class="text-thin text-white text-subtitle1 shadow-6"
							v-for="(weak, typeIndex) in weakness"
							:key="`${typeIndex}A`"
							>{{ weak }}</q-chip
						>
					</div>
				</div>
			</div>

			<div class="col-12 col-md-7">
				<div
					class="q-mx-md column q-gutter-y-md q-mt-sm"
					:class="{ 'q-ml-lg': $q.screen.gt.sm }"
				>
					<header-title class="gt-sm" :title="details.name" />

					<span class="text-subtitle1 gt-sm">
						{{ getDescription }}
					</span>

					<div class="stats row">
						<primary-title title="Stats" />
						<stats class="col-12 q-my-sm" :stats="details.stats" />
					</div>

					<div class="skills row">
						<primary-title title="Abilities" />
						<abilities class="q-mx-md q-my-md" :abilities="details.abilities" />
					</div>
				</div>
			</div>
		</div>
		<div class="row q-my-lg q-mx-md" v-if="!notFound && !loading">
			<div class="col-12 q-gutter-y-md">
				<primary-title title="Evolutions" />
				<evolve :evolutions="evolutions" />
			</div>
		</div>
		<not-found v-if="notFound && !loading" />
	</div>
</template>

<script>
	import axios from "axios";
	import { typeColor } from "src/components/mixins/colorMixins";
	import NotFound from "src/components/pokemon/NotFound.vue";
	import { mapActions, mapMutations } from "vuex";
	import HeaderTitle from "src/components/typography/header-title.vue";
	import PrimaryTitle from "src/components/typography/primary-title.vue";
	import Stats from "src/components/pokemon/Stats.vue";
	import Abilities from "src/components/pokemon/Abilities.vue";
	import Evolve from "src/components/pokemon/Evolve.vue";
	import Breadcrumbs from "src/components/layouts/Breadcrumbs.vue";
	export default {
		name: "ShowPage",
		mixins: [typeColor],
		components: {
			NotFound,
			HeaderTitle,
			PrimaryTitle,
			Stats,
			Abilities,
			Evolve,
			Breadcrumbs,
		},
		data: () => ({
			details: {},
			species: null,
			strengths: [],
			weakness: [],
			evolutions: [],
			notFound: false,
			loading: true,
			profileImage: null,
		}),

		computed: {
			getDescription() {
				if (!this.species) return "- -";

				//finding english language

				let findEnDescription = this.species.flavor_text_entries.find(
					(detail) => detail.language.name === "en"
				);

				return findEnDescription.flavor_text;
			},
		},

		methods: {
			...mapActions("pokemon", ["setData"]),
			...mapMutations("pokemon", ["updateSearch", "clearPokemon"]),
			async fetchData() {
				this.clearState();
				this.loading = true;
				this.$q.loading.show();
				this.callApiData();
			},

			async callApiData() {
				const res = await this.setData({
					name: this.$route.params.name,
					show: true,
				});

				if (res.status === 404) {
					this.notFound = true;
					this.$q.loading.hide();
					this.loading = false;
				} else {
					this.setDetails(res);
					this.notFound = false;
				}
			},

			async setDetails(res) {
				const { name, id, sprites, types, species } = res.data;

				//get strenghts and weakness

				let weakness = []; //double_damage_from
				let strengths = []; //double_damage_to

				const setStrWeakness = types.map(async (type) => {
					let typeRes = await axios.get(type.type.url);

					let typeData = typeRes.data.damage_relations;

					let weaknessParsed = typeData.double_damage_from.map(
						(weakness) => weakness.name
					);

					let strengthParsed = typeData.double_damage_to.map((str) => str.name);

					weakness = [...weakness, ...weaknessParsed];
					strengths = [...strengths, ...strengthParsed];
				});

				// remove duplicates

				//wait for map to finish
				await Promise.all(setStrWeakness);

				this.strengths = [...new Set(strengths)];
				this.weakness = [...new Set(weakness)];

				//get species

				const speciesData = await axios.get(species.url);

				this.species = speciesData.data;

				//get evolution

				const evolutionResponse = await axios.get(
					this.species.evolution_chain.url
				);

				//fetch species data

				let evolveChain = evolutionResponse.data.chain;

				let baseEvolve = await axios.get(
					`https://pokeapi.co/api/v2/pokemon/${evolveChain.species.name}`
				);
				this.evolutions.push(baseEvolve.data);
				//normal evolve

				evolveChain.evolves_to.map(async (detail) => {
					const evolutionData = await axios.get(
						`https://pokeapi.co/api/v2/pokemon/${detail.species.name}`
					);

					this.evolutions.push(evolutionData.data);

					if (detail.evolves_to.length) {
						const lastEvolve = await axios.get(
							`https://pokeapi.co/api/v2/pokemon/${detail.evolves_to[0].species.name}`
						);

						this.evolutions.push(lastEvolve.data);
					}
				});

				// let evolutionData = await this.api(`pokemon/${}`)

				this.details = res.data;

				// chain condition in case the first val does not exist
				this.profileImage =
					sprites.other?.dream_world?.front_default ??
					sprites.other["official-artwork"].front_default ??
					sprites.front_default;

				this.$q.loading.hide();
				this.loading = false;
			},

			clearState() {
				this.details = {};
				this.strengths = [];
				this.weakness = [];
				this.evolutions = [];
			},
		},

		async created() {
			this.clearPokemon();
			this.fetchData();
		},

		beforeDestroy() {
			this.updateSearch(null);
		},

		watch: {
			"$route.params.name"() {
				this.fetchData();
			},
		},
	};
</script>

<style scoped lang="scss">
	.avatar {
		filter: drop-shadow(6px 11px 8px #222);
	}
</style>